pfSense Packages - Bug #11031

FRR: PHP error in frr_bgp.inc
11/03/2020 05:43 PM - Steve Wheeler

Status: Resolved Start date: 11/03/2020

Priority: Normal Due date:

Assignee: Jim Pingle % Done: 0%

Category: FRR Estimated time: 0.00 hour

Target version: 250

Affected Version: 2.5.x Affected All
Architecture:

Description
| am seeing an error at boot triggered by FRR:

Crash report begins. Anonymous machine information:
amd o4

12.2-STABLE

FreeBSD 12.2-STABLE 2841d41b090 (devel-12) pfSense
Crash report details:

PHP Errors:

[03-Nov-2020 22:11:14 Europe/London] PHP Warning: Invalid argument supplied for foreach() in /usr
/local/pkg/frr/inc/frr_bgp.inc on line 454

Testing pkg 0.6.8_7 in:

2.5.0-DEVELOPMENT (amd64)
built on Tue Nov 03 13:01:01 EST 2020
FreeBSD 12.2-STABLE

Config triggering this is:

<frr>
<config>
<enable>on</enable>
<password><! [CDATA [password2]]></password>
<carpstatusvid>none</carpstatusvid>
<logging></logging>
<routerid>172.21.16.167</routerid>
<ignoreipsecrestart></ignoreipsecrestart>
<enablesnmpagentx></enablesnmpagentx>
<row>
<routevalue></routevalue>
<routetarget>none</routetarget>
</row>
</config>
</frr>
<frrbgp>
<config>

<enable>on</enable>

05/18/2021 1/3




<adjacencylog>on</adjacencylog>
<asnum>60001</asnum>
<routerid></routerid>
<timers_keepalive></timers_keepalive>
<timers_holdtime></timers_holdtime>
<timers_updatedelay></timers_updatedelay>
<timers_peerwait></timers_peerwait>
<nodefipv4unicast></nodefipv4unicast>
<enablesnmpagentx></enablesnmpagentx>
<enablerpki></enablerpki>
<rpkipollingperiod></rpkipollingperiod>
<rpkiexpireinterval></rpkiexpireinterval>
<rpkiretryinterval></rpkiretryinterval>
<redistributeconnectedsubnets>ipvi4</redistributeconnectedsubnets>
<redistributestatic>no</redistributestatic>
<redistributekernel>no</redistributekernel>
<redistributeospf>no</redistributeospf>
<row>
<distributeroutevalue></distributeroutevalue>
<distributeroutemap>none</distributeroutemap>
</row>
</config>

</frrbgp>
<frrbgpneighbors>
<config>
<peer>172.21.16.180</peer>
<descr><! [CDATA[244dev]]></descr>
<peergroup>none</peergroup>
<password></password>
<password_type><! [CDATA[none]]></password_type>
<asnum>60001</asnum>
<updatesource_type>ipvid</updatesource_type>
<updatesource>default</updatesource>
<defaultoriginate>no</defaultoriginate>
<sendcommunity>disabled</sendcommunity>
<nexthopself>disabled</nexthopself>
<softreconfigurationinbound></softreconfigurationinbound>
<timers_keepalive></timers_keepalive>
<timers_holdtime></timers_holdtime>
<timers_connect></timers_connect>
<distribute_in>none</distribute_in>
<distribute_out>none</distribute_out>
<prefixfilter_in>none</prefixfilter_in>
<prefixfilter_out>none</prefixfilter_out>
<aspathfilter_in>none</aspathfilter_in>
<aspathfilter_out>none</aspathfilter_out>
<routemap_in>none</routemap_in>
<routemap_out>none</routemap_out>
<unsuppressmap>none</unsuppressmap>
<bfdenable></bfdenable>
<bfd_check_control_plane_failure></bfd_check_control_plane_failure>
<bfd_peer>default</bfd_peer>
<weight></weight>
<passive></passive>
<addpathtxallpaths></addpathtxallpaths>
<addpathtxbestpathperas></addpathtxbestpathperas>
<advertisementinterval></advertisementinterval>
<allowasin>disabled</allowasin>
<asoverride></asoverride>
<attributeunchanged></attributeunchanged>
<attributeunchanged_aspath></attributeunchanged_aspath>
<attributeunchanged_med></attributeunchanged_med>
<attributeunchanged_nexthop></attributeunchanged_nexthop>
<capability>disabled</capability>
<dontcapabilitynegotiate></dontcapabilitynegotiate>
<overridecapability></overridecapability>
<ttlsecurityhops></ttlsecurityhops>
| had installed that only to test the FRR pkg install so it's the minimum data required to start FRR services rather than be anything

useful.

<disableconnectedcheck></disableconnectedcheck>
<ebgpmultihop></ebgpmultihop>
<enforcemultihop></enforcemultihop>
<localas_num></localas_num>
<localas_noprepend></localas_noprepend>
<localas_replaceas></localas_replaceas>
<maximumprefix_num></maximumprefix_num>
<maximumprefix_threshold></maximumprefix_threshold>
<maximumprefix_warnonly></maximumprefix_warnonly>
<maximumprefix_restart></maximumprefix_restart>
<removeprivateas></removeprivateas>
<removeprivateas_all></removeprivateas_all>
<removeprivateas_replace></removeprivateas_replace>
<routeclient_reflector></routeclient_reflector>

<routeclient_server></routeclient_server>
<solo></solo>
</config>
</frrbgpneighbors>
<frrospfd>
<config></config>
</frrospfd>
<frrospf6d>
<config></config>
</frrospfed>
<frrglobalacls>
</frrglobalacls>
<frrglobalroutemaps>
</frrglobalroutemaps>
<frrospfdinterfaces>
</frrospfdinterfaces>
<frrospfdareas>
</frrospfdareas>

FRR does start and run including BGP but is not running at boot after hitting that error. It can be started manually after that.

History

#1 - 11/04/2020 03:32 AM - Viktor Gurov

Fix:

https://gitlab.netgate.com/pfSense/FreeBSD-ports/-/merge_requests/5

#2 - 11/04/2020 05:18 AM - Renato Botelho

- Status changed from New to Feedback

PR has been merged. Thanks!

#3 - 11/04/2020 11:09 AM - Steve Wheeler

- Status changed from Feedback to Resolved

Tested in pkg 0.6.8_8

Looks good. Starts at boot correctly. No errors generated.
